import org.junit.Rule;
import org.junit.Test;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.lang.reflect.Method;

import org.junit.contrib.java.lang.system.StandardOutputStreamLog;
import org.junit.rules.Timeout;

import static org.junit.Assert.assertEquals;

public class Aufgabe3Test {

    @Rule
    public final StandardOutputStreamLog log = new StandardOutputStreamLog();

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Test
    public void testOutput() {
        System.out.println();
        System.out.println("Test-Output zu Aufgabe3:");

        String[] testValues = new String[]{"", "Test-Output zu Aufgabe3:", "1 rec(4, 0)", "2 rec(3, 1)", "3 rec(2, 2)", "4 rec(1, 3)", "5 rec(0, 4)", "6 simple(5)", "7 rec(0, 6)", "8 simple(7)", "9 rec(1, 8)", "10 rec(0, 9)", "11 simple(10)", "12 rec(0, 11)", "13 simple(12)", "14 rec(2, 13)", "15 rec(1, 14)", "16 rec(0, 15)", "17 simple(16)", "18 rec(0, 17)", "19 simple(18)", "20 rec(1, 19)", "21 rec(0, 20)", "22 simple(21)", "23 rec(0, 22)", "24 simple(23)", "25 rec(3, 24)", "26 rec(2, 25)", "27 rec(1, 26)", "28 rec(0, 27)", "29 simple(28)", "30 rec(0, 29)", "31 simple(30)", "32 rec(1, 31)", "33 rec(0, 32)", "34 simple(33)", "35 rec(0, 34)", "36 simple(35)", "37 rec(2, 36)", "38 rec(1, 37)", "39 rec(0, 38)", "40 simple(39)", "41 rec(0, 40)", "42 simple(41)", "43 rec(1, 42)", "44 rec(0, 43)", "45 simple(44)", "46 rec(0, 45)"};
        StringBuilder testString = new StringBuilder();
        for(String i: testValues) {
            testString.append(i).append(System.lineSeparator());
        }
        Aufgabe3.main(new String[]{});
        assertEquals(testString.toString(), log.getLog());
    }

}