import org.junit.Rule;
import org.junit.Test;
import java.lang.reflect.Method;
import org.junit.rules.Timeout;

import static org.junit.Assert.assertEquals;

public class Aufgabe4Test {

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Test
    public void testRec() throws Exception{
        Method method = Aufgabe4.class.getDeclaredMethod("rec", int.class);
        assertEquals(true, method.getReturnType().equals(Integer.TYPE));
        method.setAccessible(true);
        assertEquals(0, method.invoke(null, 0));
        assertEquals(0, method.invoke(null, 1));
        assertEquals(1, method.invoke(null, 2));
        assertEquals(2, method.invoke(null, 3));
        assertEquals(2, method.invoke(null, 4));
        assertEquals(3, method.invoke(null, 5));
        assertEquals(95, method.invoke(null, 500));
        assertEquals(168, method.invoke(null, 1000));
    }
}